rm(list=ls())

#charger les donnes
library(xlsReadWrite)
setwd("D:/DataMining/Databases_for_mining/comparison_TOW/clustering_deploiement/banque")
donnees <- read.xls(file="banque_classif_deploiement.xls",sheet=1)
summary(donnees)

#index des individus actifs et illustratifs
id.actif <- which(donnees$statut=="actif")
id.illus <- which(donnees$statut=="supplementaire")
print(id.actif)
print(id.illus)

#chargement de la librairie FactoMineR
library(FactoMineR)

#acm, avec partition individus actifs et supplmentaires
#la colonne statut n'est pas utilise
#les nb.axes premiers axes sont demands
nb.axes <- 10
X <- donnees[,-9]
modele.acm <- MCA(X,ncp=nb.axes,ind.sup=id.illus,graph=FALSE)
print(summary(modele.acm$ind$coord))
print(summary(modele.acm$ind.sup$coord))

#k-means sur les axes de l'ACM (individus actifs)
nb.classes <- 2
set.seed(10)
modele.kmeans <- kmeans(modele.acm$ind$coord,centers = nb.classes,algorithm="MacQueen",iter.max=40)
print(modele.kmeans)

#rcupration des centres de classes dans l'espace des axes factoriels
centres <- modele.kmeans$centers
numero <- seq(from=1,to=nb.classes)
rownames(centres) <- paste("clus_",numero,sep="")
print(centres)

#classement des individus supplmentaires
#calcul sur la base d'une distance euclidienne simple
#dans l'espace des axes factoriels de l'ACM

#fonction distance euclidienne entre deux lignes
dist_euclidienne <- function(ref,a_classer){
 dist <- sum((ref-a_classer)^2)
 return(dist)
}

#pour une observation, calculer le min. de distance, et renvoyer l'indice
le_plus_proche <- function(barycentres=centres,a_classer){
  vec <- apply(barycentres,1,dist_euclidienne,a_classer)
  #renvoyer l'indice
  indice <- which.min(vec)
  return(indice)
}

#enchaner tout cela pour chaque individu supplmentaire
resultat <- apply(modele.acm$ind.sup$coord,1,le_plus_proche,barycentres=centres)
resultat <- as.factor(resultat)
print(summary(resultat))

#******************************************
#croiser les rsultats avec ceux de Tanagra
#******************************************
#renumroter les individus de 1  100
names(resultat) <- 1:100
#charger les clusters de Tanagra
tanagra.clus <- read.table(file="tanagra_clusters.txt",header=T)
#confronter
croisement <- table(resultat,tanagra.clus$Cluster_KMeans_1)
print(croisement)


